%define _x11bindir /usr/X11R6/bin
%define _x11datadir /usr/X11R6/lib
%{?!_with_256_color: %define _with_256_color 1}
%{?!_with_tek4014: %define _with_tek4014 1}
%{?!DEBUGINFO:     %define DEBUGINFO    1}
%{?!enable_trace:  %define enable_trace 0}

Summary: xterm terminal emulator for the X Window System
Name: xterm
Version: 213
Release: 1.FC4
URL: http://dickey.his.com/xterm
License: MIT
Group: User Interface/X
BuildRoot: %{_tmppath}/%{name}-root
Source0: ftp://dickey.his.com/xterm/%{name}-%{version}.tgz
Patch0: xterm-can-2003-0063.patch
Patch1: xterm-resources-redhat.patch
Patch2: xterm-179-ppc-fix-bug-101472.patch
Patch3: xterm-tty-group-name.patch
Patch4: xterm-appsdir.patch
Patch5: xterm-208-root-grab-console.patch
Patch6: xterm-208-bz180450.patch
Patch7: xterm-208-bz182382.patch
Patch8: xterm-208-reverse-video-set-cursor-gcs.patch
Patch9: xterm-212-bz186935.patch
Patch10:xterm-212-man-page_paths.patch
Patch11:xterm-213-bz189161.patch
BuildRequires: xorg-x11-devel >= 6.7.0
BuildRequires: utempter libtermcap-devel

%description
The xterm program is a terminal emulator for the X Window System. It
provides DEC VT102 and Tektronix 4014 compatible terminals for
programs that can't use the window system directly.

%prep
%setup -q
# The xterm source code used to decompress with all of the files read-only,
# but appears to be fixed now
#chmod -R u+w .
%patch0 -p0 -b .can-2003-0063
%patch1 -p1 -b .resources-redhat
%ifarch ppc ppc64
#%patch2 -p0 -b .ppc-fix-bug-101472
%endif
%patch3 -p1 -b .tty-group-name
%patch4 -p1 -b .appsdir
%patch5 -p1 -b .root-grab-console
#%patch6 -p1 -b .bz180450
#      ^- patch now upstream
#%patch7 -p1 -b .bz182382
#      ^- patch now upstream
#%patch8 -p1 -b .bz183993
#      ^- patch now upstream
%patch9 -p1 -b .bz186935
%patch10 -p1 -b .man-page_paths
%patch11 -p1 -b .bz189161

%if !%{DEBUGINFO}
%define debug_package %{nil}
%endif

%build
%if %{DEBUGINFO}
export CFLAGS="$RPM_OPT_FLAGS"
%else
export CFLAGS=`echo $RPM_OPT_FLAGS | sed 's/-O2 -g/-g3 -gdwarf-2/g'`;
%endif
%configure --enable-luit \
           --enable-warnings \
           --enable-wide-chars \
           --with-utempter \
%if !%{_with_tek4014}
           --disable-tek4014 \
%endif
%if %{_with_256_color}
           --enable-256-color \
%endif
%if %{enable_trace}
	   --enable-trace \
%endif
;
export XTERM_TTY_GROUP_NAME=tty;
make

%install
rm -rf $RPM_BUILD_ROOT
%makeinstall appsdir=$RPM_BUILD_ROOT/%{_x11datadir}/X11/app-defaults apploaddir=%{_x11datadir}/X11/app-defaults
#install-ti

mkdir -p $RPM_BUILD_ROOT/%{_mandir}/man1
mkdir -p $RPM_BUILD_ROOT/%{_x11datadir}/X11/app-defaults

mv $RPM_BUILD_ROOT/%{_mandir}/*.1 $RPM_BUILD_ROOT/%{_mandir}/man1/

# Make a compatibility symlink for xterm, so that applications and scripts
# which invoke xterm explicitly as /usr/X11R6/bin/xterm, will continue to work
# correctly without surprises
{
  mkdir -p $RPM_BUILD_ROOT%{_x11bindir}
  ln -sf ../../bin/xterm $RPM_BUILD_ROOT%{_x11bindir}/xterm
}
%if !%{DEBUGINFO}
/usr/lib/rpm/brp-compress
exit 0
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
%{_bindir}/resize
%{_bindir}/uxterm
%{_bindir}/xterm
%{_mandir}/man1/resize.1*
%{_mandir}/man1/xterm.1*
%{_x11datadir}/X11/app-defaults/UXTerm
%{_x11datadir}/X11/app-defaults/XTerm
%{_x11datadir}/X11/app-defaults/XTerm-color
%{_x11bindir}/xterm

%changelog
* Wed May 31 2006 Jason Vas Dias <jvdias@redhat.com> - 213-1
- Upgrade to upstream version 213 (fixes bug 192627)
- fix bug 189161 : make -r/-rv do reverseVideo with or without
                   xterm*{fore,back}ground set

* Thu Apr 13 2006 Jason Vas Dias <jvdias@redhat.com> - 212-1
- Upgrade to upstream version 212
- fix bug 188031 : paths in man-page 
- fix bug 186935 : segfault on VisualBell in `screen' 
- fix bug 186170 : revert charClass uncommenting 
- fix bug 186094 : utfTitle

* Tue Mar 07 2006 Jason Vas Dias <jvdias@redhat.com> - 208-4.FC4
- fix bug 183993: call set_cursor_gcs in ReverseVideo

* Wed Feb 22 2006 Jason Vas Dias <jvdias@redhat.com> - 208-2.FC4
- fix bug 182382: check for (VWindow(screen)!=0) in set_cursor_gcs
- further fix for bug 178302: allow vt100*cursorColor to be same 
  as foreground 

* Tue Feb 14 2006 Jason Vas Dias <jvdias@redhat.com> - 208-1.FC4
- Upgrade to upstream version 208
- fix bug 180450: disallow Bell() generation before 
  'term' widget is realized

* Wed Dec 21 2005 Jason Vas Dias <jvdias@redhat.com> - 207-2.FC4
- Fix bug 164210: tek4014 support should be enabled by default
- Fix bug 175684: compile with --enable-256-color

* Tue Nov 22 2005 Jason Vas Dias <jvdias@redhat.com> - 207-1.FC4
- Upgrade to upstream version 207.
- re-fix bug 155538 inadvertently broken by last update:
  Modify only the bare minimum xresources necessary for correct
  backspace operation.

* Wed Oct 12 2005 Jason Vas Dias <jvdias@redhat.com> 205-1
- Upgrade to upstream version 205 
  fixes bugs: 124421, 129146, 159562, 161894, 169347
 
* Sat Sep 24 2005 Mike A. Harris <mharris@redhat.com> 200-10
- Updated xterm-resources-redhat.patch to add "xterm*ttyModes: erase ^?"
  resource to fix bug (#155538,160354,163812,162549)
  
* Wed Sep 14 2005 Mike A. Harris <mharris@redhat.com> 200-9
- Updated xterm-resources-redhat.patch to remove utf8 resource which was
  added in the 200-7 build, as it was incorrectly set to 'true' instead
  of '1', and bug #138681 turned out to be a gdm bug instead of an xterm
  bug.  This fixes bug (#163568).
  
* Mon Aug 29 2005 Mike A. Harris <mharris@redhat.com> 200-8
- Added --disable-tek4014 to ./configure flags, to disable tek support
  for bug (#164210)

* Mon May 2 2005 Mike A. Harris <mharris@redhat.com> 200-7
- Updated xterm-resources-redhat.patch to enable xterm utf8 resource by
  default, as our default OS environment is UTF-8, for bug (#138681)

* Sat Apr 16 2005 Mike A. Harris <mharris@redhat.com> 200-6
- Added option to spec file to allow easy rebuilding with 256 color option
  for those who prefer this non-default behaviour (#103402)

* Tue Mar 8 2005 Soeren Sandmann <sandmann@redhat.com> 200-5
- Ported xterm-resources-redhat.patch to newer xterms. (#126855)

* Sun Mar 6 2005 Mike A. Harris <mharris@redhat.com> 200-4
- Added libtermcap-devel and utempter to BuildRequires
- Changed BuildRequires from XFree86-devel to xorg-x11-devel

* Sun Mar 6 2005 Mike A. Harris <mharris@redhat.com> 200-3
- Rebuild with gcc 4 for FC4 development

* Mon Feb 7 2005 Mike A. Harris <mharris@redhat.com> 200-2
- Removed chmod from prep, and updated comment to refect (#128341c12)

* Mon Feb 7 2005 Mike A. Harris <mharris@redhat.com> 200-1
- Updated main tarball to xterm-200 for FC4 devel
- Disabled xterm-179-ppc-fix-bug-101472.patch for now, to see if the problem
  occurs on ppc still or not.

* Fri Jul 13 2004 Mike A. Harris <mharris@redhat.com> 192-1
- Updated main tarball to xterm-192 for FC3 devel
- Resolved bugs #126569,127132

* Fri Jun 18 2004 Mike A. Harris <mharris@redhat.com> 191-1
- Updated main tarball to xterm-191 for FC3 devel
- Disabled xterm-resources-redhat.patch to see what if anything breaks, as
  it no longer applies cleanly.  Hopefully we can just ship stock xterm
  resources now, although I realize that is more likely to be a pie in the
  sky fantasy once the bug reports trickle in from this change.  ;o)
  
* Tue Jun 15 2004 Elliot Lee <sopwith@redhat.com> 179-8
- rebuilt

* Thu Jun  3 2004 Mike A. Harris <mharris@redhat.com> 179-7
- Rebuilt for FC3 devel

* Fri Feb 13 2004 Elliot Lee <sopwith@redhat.com> 179-6.EL
- rebuilt

* Mon Sep  8 2003 Mike A. Harris <mharris@redhat.com> 179-5.EL
- Rebuilt 179-5 for Taroon

* Mon Sep  8 2003 Mike A. Harris <mharris@redhat.com> 179-5
- Added xterm-179-ppc-fix-bug-101472.patch ifarch ppc ppc64 to fix bug (#101472)

* Wed Aug 27 2003 Bill Nottingham <notting@redhat.com> 179-4.1
- fix symlink
- rebuild

* Wed Aug 13 2003 Mike A. Harris <mharris@redhat.com> 179-3.EL
- Rebuilt for Taroon with symlink fixes.

* Wed Aug 13 2003 Mike A. Harris <mharris@redhat.com> 179-3
- Added symlink /usr/X11R6/bin/xterm pointing to _bindir/xterm so that apps
  and scripts which invoke xterm explicitly as /usr/X11R6/bin/xterm, will
  continue to work correctly without surprises (#101994)

* Wed Jun 04 2003 Elliot Lee <sopwith@redhat.com> 179-2.EL
- rebuilt

* Fri May 30 2003 Mike A. Harris <mharris@redhat.com> 179-1.EL
- Bump release to 1.EL for Red Hat Enterprise Linux build

* Mon May 26 2003 Mike A. Harris <mharris@redhat.com> 179-1
- Updated to upstream xterm 179
- [SECURITY] Added xterm-can-2003-0063.patch from XFree86 4.3.0-12 package
- Added Red Hat xterm-resources-redhat.patch from XFree86 4.3.0-12 package
- Added "chmod -R u+w *" after source is decompressed or else patches can not
  be applied due to upstream source being read only files
- Built xterm 179-1 in rawhide

* Mon May  5 2003 Mike A. Harris <mharris@redhat.com> 177-2.0.EL
- Bump release to 2.0.EL for Red Hat Enterprise Linux build

* Mon May  5 2003 Mike A. Harris <mharris@redhat.com> 177-2
- Build fix for lib64:  _x11datadir == /usr/X11R6/lib
- Another lib64 build fix:  xterm uses /usr/%%{_lib}/X11/app-defaults when it
  should be using an arch-neutral dir {_x11datadir}/X11/app-defaults instead

* Tue Apr 15 2003 Mike A. Harris <mharris@redhat.com> 177-1
- Call configure with "--enable-luit --enable-warnings --enable-wide-chars
  --with-utempter"
- Initial build.
